//Version 5.7
//Build Version 117069

function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
 }

function showPwdReqs(){
    if($("#newPassword")[0] != undefined){
        const pwdreqs_container = document.createElement('div');
        pwdreqs_container.setAttribute('id', 'pwdreqs');
        pwdreqs_container.style.textAlign = 'left';
        $("#api")[0].parentElement.append(pwdreqs_container);
        
        const pwdreqs_htmlString = `<br /><br/>
        <div style="padding:5px; border:1px black solid" id="pwdreqs_inner">
            <label style="font-size:14px; font-weight:bold">Password Requirements</label>
            <div style="padding-left:15px">
            1. Minimum 12 characters<br>
            2. Last 12 passwords cannot be re-used<br>
            3. The password must contain characters from all four of the following categories:<br>
            <ul style="padding-left:35px">
                <li>Uppercase characters (A-Z)</li>
                <li>Lowercase characters (a-z)</li> 
                <li>Numbers (0-9)</li>
                <li>Non-alphanumeric characters<br>(For example, !, $, #, or %)</li>
            </ul> 
            4. The password must not contain three or more consecutive characters from your email
            </div>
        </div>`
        
        $("#pwdreqs")[0].innerHTML = pwdreqs_htmlString;
    }
    return;
}

function inputFocus(){
    //If input claim exists, focus on that. Only the realm discovery uses this input. The other pages use "ReadOnlyEmail"
    
    if($("#oldPassword")[0] != undefined){
        $("#oldPassword")[0].focus();
        return;
    }
    if(($("#email")[0] != undefined) && ($("#password")[0] == undefined)){
        $("#email")[0].focus();
        return;
    }
    if($("#newPassword")[0] != undefined){
        $("#newPassword")[0].focus();
        return;
    }
    if($("#password")[0] != undefined){
        $("#ReadOnlyEmail")[0].disabled = 'true'
        $("#ReadOnlyEmail")[0].readOnly = 'true'
        $("#password")[0].focus();
        return;
    }
}

//MFA Set Up Changes (Start)
function initQRPage(){
    const qricon = ($("#totpQrCodeControl").length > 0) ? true : false;

    if((qricon == undefined) || (!qricon)){
        return;
    }

    //Remove "Can't scan? Try this" link
    $("#totpQrCodeControl a")[0].remove();

    //Add padding to instructions
    $("#totpQrCodeControl_info_message")[0].style.paddingBottom = "20px";
    
    //Change link for manual steps
    $("a#authenticatorInfoControl-collapse_text")[0].innerText = "Can't scan the QR code? Click here";

    //Remove * at end of instructions text
    $("label#QrCodeScanInstruction_label")[0].innerText = $("label#QrCodeScanInstruction_label")[0].innerText.substring(0,($("label#QrCodeScanInstruction_label")[0].innerText).length-1)

    //Add instructions and format acount details
    const manualqrsteps_htmlString = `<div style="text-align:left">In the Authenticator App:<br />&emsp;Select "or enter code manually".<br />&emsp;Enter your email address in the 'Account Name' line and the secret key provided below in the 'Secret Key' line.<br /><div>`;
    $("label#authenticatorInfoControl-title")[0].innerHTML = manualqrsteps_htmlString;

    //Add "key"
    $("#authenticatorInfoControl-secret")[0].innerText = $("#authenticatorInfoControl-secret")[0].innerText.substring(0,6) + ' key' + $("#authenticatorInfoControl-secret")[0].innerText.substring(6);    

    //Listener for when the "help" link is clicked
    $("a.authenticatorInfoCollapse").click(function() {
        sleep(10).then(() => {
            $("label#authenticatorInfoControl-title")[0].style.display = "table";
            $("#authenticatorInfoControl-account_name")[0].style.display = "table";
            $("#authenticatorInfoControl-secret")[0].style.display = "table";
        });
    });

    //Fix App Icons in new page layouts
    ////Google Play Store
    let qrappicon = $("#authenticatorAppIconControl-google img")[0];
    qrappicon.style.float = "left";
    qrappicon.style.width = "50%";

    ////Apple App Store
    qrappicon =  $("#authenticatorAppIconControl-apple img")[0];
    qrappicon.style.float = "left";
    qrappicon.style.width = "40%";
    qrappicon.style.marginTop = "10px";

    //Change text because Content Defintions/Display Controls are not updating properly 
    $("#authenticatorAppIconControl-title")[0].innerText = "Download the Microsoft Authenticator app using the download links for iOS and Android based on your mobile device.";
    
    //For hide instructions
    const qrinstructions = $("#authenticatorAppIconControl-instruction")[0];
    qrinstructions.style.visibility = "hidden"
    qrinstructions.style.display = "none";
}
//MFA Set Up Changes (End)

//Email verification Tweaks (Start)
var observer;
function initEmailTotp(){
    if($("#DiscoveredEmail").length > 0){
        $("#continue").hide(); // Hide the continue button

        // Hide DiscoveredEmail list item and copy the value to the ReadOnlyEmail input
        $(".Readonly.DiscoveredEmail_li")[0].style.display = "none";
        $("#ReadOnlyEmail")[0].value = $element.getClaimValue("DiscoveredEmail");
        $("#ReadOnlyEmail_ver_but_send")[0].click();

        // Add Listener for Verify Code button
        $("#api .verifyButton").click(function(n) {
            ($("#verifying_blurb").text($i2e.lookupLanguage("verifying_blurb")))
            $modal.showCustom("#api .verifying-modal", {
                opacity: 60,
                minHeight: 300,
                minWidth: 350,
                close: !1,
                containerCss: {
                    background: "none",
                    "text-align": "center",
                    "-webkit-box-shadow": "0 0 0 0",
                    "-moz-box-shadow": "0 0 0 0",
                    "box-shadow": "0 0 0 0"
                }
            })
        });
        
        // Listen for the continue button to be enabled by MS
        observer = new MutationObserver(function (mutations) {
            mutations.forEach(function (mutationRecord) {
                switch(mutationRecord.target.id){
                    case "continue":
                        if($("#continue")[0].getAttribute("aria-disabled") != "true"){
                            $("#continue")[0].click();
                        }
                        break;
                    case "ReadOnlyEmail_fail_retry":
                        $modal.hide();
                        break;
                }
            });
        });
        observer.observe($("#continue")[0], { attributes: true, attributeFilter: ['aria-disabled']});
        observer.observe($("#ReadOnlyEmail_fail_retry")[0], { attributes: true, attributeFilter: ['aria-hidden']});
    }
}
//Email verification Tweaks (End)

// Run changes when page loads
$( document ).ready(function() {
    sleep(100).then(() => {
        initEmailTotp();
        showPwdReqs();
        inputFocus();
        initQRPage();
    });
});